diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowFlaming.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowFlaming.java
new file mode 100644
index 000000000..1cedf70ab
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowFlaming.java
@@ -0,0 +1,130 @@
+package net.minecraft.core.entity.projectile;
+
+import net.minecraft.core.block.BlockLogicEmber;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicTNT;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.monster.MobCreeper;
+import net.minecraft.core.entity.monster.MobZombiePig;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.LightIndexHelper;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+
+
+public class ProjectileArrowFlaming extends ProjectileArrow {
+	public ProjectileArrowFlaming(World world) {
+		super(world, 4);
+		this.stack = new ItemStack(Items.AMMO_ARROW_FLAMING);
+		this.entityBrightness = 1.0F;
+	}
+
+	public ProjectileArrowFlaming(World world, double x, double y, double z) {
+		super(world, x, y, z, 4);
+		this.stack = new ItemStack(Items.AMMO_ARROW_FLAMING);
+		this.entityBrightness = 1.0F;
+	}
+
+	public ProjectileArrowFlaming(World world, Mob owner, boolean doesArrowBelongToPlayer) {
+		super(world, owner, doesArrowBelongToPlayer, 4);
+		this.stack = new ItemStack(Items.AMMO_ARROW_FLAMING);
+		this.entityBrightness = 1.0F;
+	}
+
+	@Override
+	protected void initProjectile() {
+		super.initProjectile();
+		this.damage = 6;
+		this.entityBrightness = 1.0F;
+	}
+
+	@Override
+	public float getBrightness(float partialTick) {
+		return 10.0F;
+	}
+
+	@Override
+	public float calcBrightness(float partialTick) {
+		return 1.0F;
+	}
+
+	@Override
+	public byte calcLightIndex(float partialTick) {
+		return LightIndexHelper.setBlockLight(super.calcLightIndex(partialTick), 15);
+	}
+
+	@Override
+	public void tick() {
+		world.spawnParticle("flame", this.x, this.y, this.z, this.xd * 0.05, this.yd * 0.05 - 0.1, this.zd * 0.05, 0, false);
+		world.spawnParticle("flame", this.x, this.y, this.z, this.xd * 0.05, this.yd * 0.05 - 0.1, this.zd * 0.05, 0, false);
+		world.spawnParticle("smoke", this.x, this.y, this.z, this.xd * 0.05, this.yd * 0.05 - 0.1, this.zd * 0.05, 0, false);
+		world.spawnParticle("smoke", this.x, this.y, this.z, this.xd * 0.05, this.yd * 0.05 - 0.1, this.zd * 0.05, 0, false);
+		super.tick();
+	}
+
+	@Override
+	public void onHit(@NotNull HitResult hitResult) {
+		if (hitResult instanceof HitResult.Entity hitEntity) {
+			if (hitEntity.entity instanceof MobZombiePig) {
+				hitEntity.entity.hurt(this.owner, this.damage, DamageType.COMBAT);
+			} else if (hitEntity.entity.hurt(this.owner, this.damage, DamageType.FIRE)) {
+				if (hitEntity.entity instanceof MobCreeper entityCreeper) {
+					entityCreeper.setTarget(entityCreeper);
+				}
+				hitEntity.entity.fireHurt();
+
+				if (!this.world.isClientSide) {
+					this.world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (this.random.nextFloat() * 0.2F + 0.9F));
+				}
+			}
+			this.remove();
+		} else if (hitResult instanceof HitResult.Tile hitTile && !this.world.isClientSide) {
+			int x = hitTile.tilePos.x();
+			int y = hitTile.tilePos.y();
+			int z = hitTile.tilePos.z();
+			Block<?> hitBlock = world.getBlockType(hitTile.tilePos);
+
+			x += hitTile.side.offsetX();
+			y += hitTile.side.offsetY();
+			z += hitTile.side.offsetZ();
+
+			if (world.isAirBlock(x, y, z)) {
+				world.setBlockWithNotify(x, y, z, Blocks.FIRE.id());
+			}
+
+			if (hitBlock == Blocks.BRAZIER_INACTIVE) {
+				world.setBlockType(hitTile.tilePos, Blocks.BRAZIER_ACTIVE);
+			}
+
+			if (hitBlock == Blocks.TNT) {
+				world.getBlockLogic(hitTile.tilePos, BlockLogicTNT.class).ignite(world, hitTile.tilePos, true);
+			}
+
+			if (hitBlock == Blocks.EMBER) {
+				world.getBlockLogic(hitTile.tilePos, BlockLogicEmber.class).ignite(world, hitTile.tilePos, null);
+			}
+			if (hitBlock == Blocks.ICE) {
+				world.setBlockTypeNotify(hitTile.tilePos, Blocks.FLUID_WATER_STILL);
+			}
+		}
+
+		this.remove();
+
+		super.onHit(hitResult);
+	}
+
+	@Override
+	protected void inGroundAction() {
+		world.spawnParticle("explode", this.x, this.y, this.z, this.xd * 0.05, this.yd * 0.05 - 0.1, this.zd * 0.05, 0, false);
+		world.spawnParticle("explode", this.x, this.y, this.z, this.xd * 0.05, this.yd * 0.05 - 0.1, this.zd * 0.05, 0, false);
+		world.spawnParticle("ventsmoke", this.x, this.y, this.z, this.xd * 0.05, this.yd * 0.05 - 0.1, this.zd * 0.05, 0, false);
+		world.spawnParticle("ventsmoke", this.x, this.y, this.z, this.xd * 0.05, this.yd * 0.05 - 0.1, this.zd * 0.05, 0, false);
+		world.playSoundAtEntity(null, this, "random.fizz", 0.1f, (random.nextFloat() * 1.4F + 0.8F));
+
+		super.inGroundAction();
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java
index 1746edc10..7f9171650 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java
@@ -4,6 +4,7 @@ import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.monster.MobGhast;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
@@ -14,6 +15,7 @@ import org.joml.Vector3dc;
 
 public class ProjectileFireball extends Projectile {
     public static final double FIREBALL_SPEED = 1d;
+    public static final double DEFLECTED_SPEED = 2d;
 
     public ProjectileFireball(World world) {
         super(world);
@@ -113,7 +115,9 @@ public class ProjectileFireball extends Projectile {
                 this.owner = (Mob) entity;
             }
             if (lookAngle != null) {
-                setVelocity(lookAngle.x(), lookAngle.y(), lookAngle.z(), FIREBALL_SPEED);
+                world.playSoundEffect(entity, SoundCategory.WORLD_SOUNDS, this.x, this.y, this.z, "random.drr", 1.0F, 1.3F + this.random.nextFloat() * 0.4F);
+                world.playSoundEffect(entity, SoundCategory.WORLD_SOUNDS, this.x, this.y, this.z, "random.bow", 1.0F, 1.3F + this.random.nextFloat() * 0.4F);
+                setVelocity(lookAngle.x(), lookAngle.y(), lookAngle.z(), DEFLECTED_SPEED);
             }
             return true;
         } else {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index f3a3b1df5..b5694f797 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -321,7 +321,7 @@ public class EntityBoat extends Entity {
             int blockY = MathHelper.floor(this.y);
             int blockZ = MathHelper.floor(this.z + ((double) (i / 2) - 0.5D) * 0.8D);
             Block<?> block = this.world.getBlock(blockX, blockY, blockZ);
-            if (block != null && block.hasTag(BlockTags.BOAT_BREAKS)) {
+            if (block.hasTag(BlockTags.BOAT_BREAKS)) {
                 this.world.setBlockWithNotify(blockX, blockY, blockZ, 0);
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index fabb99dc7..620ebf182 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -677,7 +677,7 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-    public void push(Entity entity) {
+    public void push(@NotNull Entity entity) {
         if (this.world.isClientSide) {
             return;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 201bb20eb..2d2785f6e 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -16,6 +16,7 @@ import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -77,6 +78,7 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
     public static final NamespaceID STATE_EMPTY = new NamespaceID("minecraft", "empty");
     public static final NamespaceID STATE_WATER = new NamespaceID("minecraft", "water");
     public static final NamespaceID STATE_LAVA  = new NamespaceID("minecraft", "lava");
+    public static final NamespaceID STATE_ACID = new NamespaceID("minecraft", "acid");
     public static final NamespaceID STATE_MILK  = new NamespaceID("minecraft", "milk");
     public static final NamespaceID STATE_ICECREAM = new NamespaceID("minecraft", "icecream");
 
@@ -100,6 +102,13 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
                 BlockLogicFluid::fizz
         ));
 
+        registerState(STATE_ACID, new BucketState(
+                "acid",
+                Blocks.FLUID_ACID_FLOWING,
+                BlockTags.IS_ACID,
+                "tile.acidbubble",
+                (world, tilePos) -> world.playBlockEvent(tilePos, LevelListener.EVENT_ACID_SPREAD, 0)));
+
         registerState(STATE_MILK, new BucketState(
                 "milk",
                 0,
@@ -210,6 +219,11 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
             }
 
             if (currentState.canPlace()) {
+                NamespaceID aimedFluid = getFluidStateAt(world, tilePos);
+                if (currentStateId.equals(aimedFluid) && getCharges(itemStack) < this.maxCharges) {
+                    return itemStack;
+                }
+
                 HitResult hitResultNoFluid = player.rayCast(reachDistance, 1f, false, false, false);
                 if (hitResultNoFluid instanceof HitResult.Tile hitTileNoFluid) {
                     return tryPlaceFluid(itemStack, world, player, hitTileNoFluid);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
index da56e8899..d68dc74dc 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.BlockLogicBrazier;
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.BlockLogicTNT;
 import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.sound.SoundCategory;
@@ -29,10 +30,18 @@ public class ItemFireStriker extends Item {
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        blockPos = blockPos.add(side.direction(), new TilePos());
-        if (world.isAirBlock(blockPos)) {
-            if (world.setBlockTypeNotify(blockPos, Blocks.FIRE)) {
-                world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) blockPos.x() + 0.5D, (double) blockPos.y() + 0.5D, (double) blockPos.z() + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
+        Block<?> clickedBlock = world.getBlockType(blockPos);
+
+        TilePos firePos = blockPos.add(side.direction(), new TilePos());
+
+        if (world.isAirBlock(firePos)) {
+            Block<?> fireToPlace = Blocks.FIRE;
+            if (clickedBlock.hasTag(BlockTags.INFINITE_BURN_SULFURIC)) {
+                fireToPlace = Blocks.FIRE_SULFURIC;
+            }
+
+            if (world.setBlockTypeNotify(firePos, fireToPlace)) {
+                world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) firePos.x() + 0.5D, (double) firePos.y() + 0.5D, (double) firePos.z() + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
                 selfStack.damageItem(1, player);
                 return true;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
index 4fbc6bc9b..9f20a442d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
@@ -169,4 +169,11 @@ public class ItemPaintBrush extends Item {
             tag.putInt("Color", color.itemMeta);
         }
     }
+
+    @Override
+    public @NotNull String getLanguageKey(@NotNull ItemStack selfStack) {
+        DyeColor color = getColor(selfStack);
+        if (color != null) return super.getKey() + "." + color.colorID;
+        return super.getKey();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemRubyglassGrowth.java b/game/core/src/main/java/net/minecraft/core/item/ItemRubyglassGrowth.java
new file mode 100644
index 000000000..010c6701e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemRubyglassGrowth.java
@@ -0,0 +1,66 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+import static net.minecraft.core.block.BlockLogicGrowthRubyglass.STATE_BUD;
+
+public class ItemRubyglassGrowth extends Item {
+
+	public ItemRubyglassGrowth(@NotNull String translationKey, @NotNull String namespaceId, int id, Block<?> block) {
+		super(translationKey, namespaceId, id);
+		this.maxStackSize = 64;
+	}
+
+	@Override
+	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+		if (player == null) return false;
+
+		TilePos placePos = new TilePos(blockPos);
+
+		if (!world.canPlaceInsideBlock(placePos)) {
+			placePos = placePos.add(side.direction(), new TilePos());
+		}
+
+		if (!Blocks.RUBYGLASS_GROWTH.getLogic().canPlaceAt(world, placePos)) return false;
+
+		if (world.setBlockTypeNotify(placePos, Blocks.RUBYGLASS_GROWTH)) {
+			Blocks.RUBYGLASS_GROWTH.getLogic().onPlacedByMob(world, placePos, side, player, xHit, yHit);
+
+			world.playBlockSoundEffect(player, (float) placePos.x() + 0.5F, (float) placePos.y() + 0.5F, (float) placePos.z() + 0.5F, Blocks.RUBYGLASS_GROWTH, EnumBlockSoundEffectType.PLACE);
+			Blocks.RUBYGLASS_GROWTH.onPlacedOnSide(world, placePos, side, 0.5, 0.5);
+
+			selfStack.consumeItem(player);
+			return true;
+		}
+
+		return false;
+	}
+
+	@Override
+	public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+		TilePos placePos = new TilePos(blockPos);
+
+		if (!world.canPlaceInsideBlock(placePos)) {
+			placePos = placePos.add(direction, new TilePos());
+		}
+
+		if (Blocks.RUBYGLASS_GROWTH.getLogic().canPlaceAt(world, placePos)) {
+			world.setBlockTypeDataNotify(placePos, Blocks.RUBYGLASS_GROWTH, STATE_BUD);
+			world.playBlockSoundEffect(null, (float) placePos.x() + 0.5F, (float) placePos.y() + 0.5F, (float) placePos.z() + 0.5F, Blocks.RUBYGLASS_GROWTH, EnumBlockSoundEffectType.PLACE);
+			selfStack.consumeItem(null);
+		}
+	}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index 3141a025f..d99e64d24 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -210,7 +210,7 @@ public final class Items {
     public static Item DOUGH;
     public static Item WAND_NBT;
 //    public static Item RUBYGLASS_DUST;
-    public static Item RUBYGLASS_CRYSTAL;
+    public static Item RUBYGLASS;
     public static Item TIMER;
 
     public static Item ARMOR_WOLF_LEATHER;
@@ -220,6 +220,14 @@ public final class Items {
     public static Item ARMOR_WOLF_GOLD;
     public static Item ARMOR_WOLF_STEEL;
 
+    public static Item SULFUR;
+    public static Item AMMO_ARROW_FLAMING;
+
+    public static Item STATUE_SLATE;
+    public static Item STATUE_PERMAFROST;
+    public static Item STATUE_NETHERRACK;
+    public static Item STATUE_GLOOMSTONE;
+
     private static boolean hasInit = false;
     public static void init(){
         if (hasInit) return;
@@ -444,8 +452,8 @@ public final class Items {
         FOOD_VENISON_COOKED = (new ItemFood("food.venison.cooked", "minecraft:item/food_venison_cooked", 16551, 12, 8, true, 4));
         DOUGH = (new Item("dough", "minecraft:item/dough", 16552));
         WAND_NBT = new ItemWandNBT("wand.nbt", "minecraft:item/wand_nbt", 16553);
-//        RUBYGLASS_DUST = (new Item("rubyglass.crystal.cracked", "minecraft:item/rubyglass_crystal_cracked", 16554));
-        RUBYGLASS_CRYSTAL = (new Item("rubyglass.crystal.pure", "minecraft:item/rubyglass_crystal_pure", 16555));
+
+        RUBYGLASS = (new Item("rubyglass", "minecraft:item/rubyglass_crystal", 16555));
 
 
         ARMOR_WOLF_LEATHER = new ItemArmor<>("armor.wolf.leather", "minecraft:item/armor_wolf_leather", 16556, ArmorMaterial.LEATHER, WolfArmorShape.BODY);
@@ -457,5 +465,14 @@ public final class Items {
 
         BUCKET_IRON = (new ItemBucketIron("bucket.iron", "minecraft:item/bucket_iron", 16562));
         BUCKET_STEEL = (new ItemBucketSteel("bucket.steel", "minecraft:item/bucket_steel", 16563));
+
+        SULFUR = new Item("sulfur", "minecraft:item/sulfur", 16567);
+        AMMO_ARROW_FLAMING = new Item("ammo.arrow.flaming", "minecraft:item/ammo_arrow_flaming", 16568);
+
+        STATUE_SLATE = new ItemStatue("statue.slate", "minecraft:item/statue_slate", 16571, Blocks.STATUE_SLATE_LOWER, Blocks.STATUE_SLATE_UPPER);
+        STATUE_PERMAFROST = new ItemStatue("statue.permafrost", "minecraft:item/statue_permafrost", 16572, Blocks.STATUE_PERMAFROST_LOWER, Blocks.STATUE_PERMAFROST_UPPER);
+        STATUE_NETHERRACK = new ItemStatue("statue.netherrack", "minecraft:item/statue_netherrack", 16573, Blocks.STATUE_NETHERRACK_LOWER, Blocks.STATUE_NETHERRACK_UPPER);
+        STATUE_GLOOMSTONE = new ItemStatue("statue.gloomstone", "minecraft:item/statue_gloomstone", 16574, Blocks.STATUE_GLOOMSTONE_LOWER, Blocks.STATUE_GLOOMSTONE_UPPER);
+
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/material/ToolMaterial.java b/game/core/src/main/java/net/minecraft/core/item/material/ToolMaterial.java
index 32919fec2..95768cb9f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/material/ToolMaterial.java
+++ b/game/core/src/main/java/net/minecraft/core/item/material/ToolMaterial.java
@@ -7,7 +7,7 @@ public class ToolMaterial {
 	public static final ToolMaterial iron = new ToolMaterial().setDurability(384).setEfficiency(6.0f, 8.0f).setMiningLevel(2);
 	public static final ToolMaterial steel = new ToolMaterial().setDurability(4608).setEfficiency(7.0f, 14.0f).setMiningLevel(3);
 	public static final ToolMaterial diamond = new ToolMaterial().setDurability(1536).setEfficiency(14.0f, 45.0f).setMiningLevel(3).setDamage(4).setBlockHitDelay(4);
-	public static final ToolMaterial gold = new ToolMaterial().setDurability(256).setEfficiency(7.0f, 12f).setMiningLevel(2).setSilkTouch(true);
+	public static final ToolMaterial gold = new ToolMaterial().setDurability(384).setEfficiency(7.0f, 12f).setMiningLevel(2).setSilkTouch(true).setBlockHitDelay(4);
 	
 	private int miningLevel;
 	private int durability;
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java
index 38e49f8fb..359de42bf 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java
@@ -51,6 +51,7 @@ public class ArgumentTypeParticleId implements ArgumentType<String> {
         particleIds.add("ashmote");
         particleIds.add("ventsmoke");
         particleIds.add("rubyglassLightning");
+        particleIds.add("acidBoiling");
     }
 
     private static final List<String> EXAMPLES = Arrays.asList("fireflyGreen", "explode", "soulflame");
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java b/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
index f2cec404d..00c9503b1 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
@@ -15,6 +15,7 @@ import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.generate.feature.*;
+import net.minecraft.core.world.generate.feature.hanging.WorldFeatureHangingDungeon;
 import net.minecraft.core.world.generate.feature.tree.*;
 import net.minecraft.core.world.generate.feature.tree.spooner.*;
 import org.jetbrains.annotations.NotNull;
@@ -211,6 +212,11 @@ public class CommandHelper {
         registerWorldFeatureClass(WorldFeatureSpoonerTreeRainforest.class);
         registerWorldFeatureClass(WorldFeatureSpoonerTreeRound.class);
         registerWorldFeatureClass(WorldFeatureSpoonerTreeStick.class);
+
+        registerWorldFeatureClass(WorldFeatureHangingDungeon.Gloomstone.class, "HangingDungeonGloomstone");
+        registerWorldFeatureClass(WorldFeatureHangingDungeon.Basalt.class, "HangingDungeonBasalt");
+        registerWorldFeatureClass(WorldFeatureHangingDungeon.Netherrack.class, "HangingDungeonNetherrack");
+        registerWorldFeatureClass(WorldFeatureHangingDungeon.Slate.class, "HangingDungeonSlate");
     }
 
     public static <T extends WorldFeatureInterface> void registerWorldFeatureClass(@NotNull final Class<T> tClass) {
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java b/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
index 18413628b..99a71308e 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
@@ -4,23 +4,7 @@ import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
-import net.minecraft.core.net.entity.entries.NetEntryAnimal;
-import net.minecraft.core.net.entity.entries.NetEntryArrow;
-import net.minecraft.core.net.entity.entries.NetEntryBoat;
-import net.minecraft.core.net.entity.entries.NetEntryBobber;
-import net.minecraft.core.net.entity.entries.NetEntryCannonball;
-import net.minecraft.core.net.entity.entries.NetEntryEgg;
-import net.minecraft.core.net.entity.entries.NetEntryFallingBlock;
-import net.minecraft.core.net.entity.entries.NetEntryFireball;
-import net.minecraft.core.net.entity.entries.NetEntryFirefly;
-import net.minecraft.core.net.entity.entries.NetEntryItem;
-import net.minecraft.core.net.entity.entries.NetEntryMinecart;
-import net.minecraft.core.net.entity.entries.NetEntryPainting;
-import net.minecraft.core.net.entity.entries.NetEntryPebble;
-import net.minecraft.core.net.entity.entries.NetEntryPlayerServer;
-import net.minecraft.core.net.entity.entries.NetEntrySnowball;
-import net.minecraft.core.net.entity.entries.NetEntrySquid;
-import net.minecraft.core.net.entity.entries.NetEntryPrimedTNT;
+import net.minecraft.core.net.entity.entries.*;
 import net.minecraft.core.net.packet.Packet;
 import org.jetbrains.annotations.NotNull;
 
@@ -150,5 +134,7 @@ public class NetEntityHandler {
         registerNetworkEntry(new NetEntryPrimedTNT(), 21);
 
         registerNetworkEntry(new NetEntryBobber(), 30);
+
+        registerNetworkEntry(new NetEntryArrowFlaming(), 32);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrowFlaming.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrowFlaming.java
new file mode 100644
index 000000000..03f87625c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrowFlaming.java
@@ -0,0 +1,55 @@
+package net.minecraft.core.net.entity.entries;
+
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.projectile.ProjectileArrowFlaming;
+import net.minecraft.core.net.entity.EntityTracker;
+import net.minecraft.core.net.entity.EntityTrackerEntry;
+import net.minecraft.core.net.entity.ITrackedEntry;
+import net.minecraft.core.net.entity.IVehicleEntry;
+import net.minecraft.core.net.packet.PacketAddEntity;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class NetEntryArrowFlaming implements IVehicleEntry<ProjectileArrowFlaming>, ITrackedEntry<ProjectileArrowFlaming> {
+
+	public NetEntryArrowFlaming() {
+	}
+
+	@Override
+	public @NotNull Class<ProjectileArrowFlaming> getAppliedClass() {
+		return ProjectileArrowFlaming.class;
+	}
+
+	@Override
+	public int getTrackingDistance() {
+		return 64;
+	}
+
+	@Override
+	public int getMovementPacketDelay() {
+		return 20;
+	}
+
+	@Override
+	public boolean sendMotionUpdates() {
+		return false;
+	}
+
+	@Override
+	public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, ProjectileArrowFlaming trackedObject) {
+	}
+
+	@Override
+	public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
+		return new ProjectileArrowFlaming(world, x, y, z);
+	}
+
+	@Override
+	public PacketAddEntity getSpawnPacket(EntityTrackerEntry tracker, ProjectileArrowFlaming trackedObject) {
+		Mob entityliving = trackedObject.owner;
+		return new PacketAddEntity(trackedObject, 0, entityliving == null ? -1 : entityliving.id, trackedObject.xd, trackedObject.yd, trackedObject.zd);
+	}
+}
